DELETE FROM Foo;
CREATE OR REPLACE FUNCTION te(OUT a int, OUT b int)
RETURNS SETOF RECORD AS 
$$
  RETURN 
    VALUES(12, 13), (16, 17);
$$ LANGUAGE plpgpsm;
INSERT INTO Foo SELECT * FROM te();

CREATE OR REPLACE FUNCTION te(OUT a int, OUT b int)
RETURNS SETOF RECORD AS 
$$
  VALUES(19, 20), (21, 22);
$$ LANGUAGE plpgpsm;
INSERT INTO Foo SELECT * FROM te();

CREATE OR REPLACE FUNCTION te(OUT a int, OUT b int)
RETURNS SETOF RECORD AS 
$$
  INSERT INTO Foo
    SELECT * 
       FROM Foo
      WHERE Foo.a < 20
      RETURNING *;
$$ LANGUAGE plpgpsm;
SELECT * FROM te();

CREATE OR REPLACE FUNCTION te(c int, OUT a int, OUT b int)
RETURNS SETOF RECORD AS 
$$
  SELECT * 
     FROM Foo
    WHERE Foo.a < c ORDER BY Foo.a;
$$ LANGUAGE plpgpsm;
SELECT * FROM te(18);

CREATE OR REPLACE FUNCTION te(OUT a int, OUT b int)
RETURNS SETOF RECORD AS 
$$
#option dump
  RETURN
    TABLE(SELECT * FROM Foo); 
$$ LANGUAGE plpgpsm;
SELECT * FROM te();

-- multiple variable assignment (simultaneous assignment)
DROP FUNCTION fx(int);
CREATE OR REPLACE FUNCTION fx(b int)
RETURNS int AS
$$
#option dump 
  BEGIN
    DECLARE x, y integer;
    DECLARE z integer DEFAULT 0;
    SET (x,y)=(10,20);
    PRINT x,y,z;
    SET (x,y,z) = (SELECT x+1,y+1, x+y);
    PRINT x,y,z;
    RETURN b;
  END
$$ LANGUAGE plpgpsm;
SELECT fx(10);
